function updateTables(table) {
    let dec=2; // how many decimals for rounding
    let row='';
    if (table=='BUCK' || table=='BOOST' || table=='ALL') { // Switcher table
        for (let i=1; i<=templateObj.config.device.buckCount+templateObj.config.device.boostCount; i++) {
            // If rail is in use
            if (i<=templateObj.config.device.buckCount) {
                if (templateObj.config.phases[i-1]!=-1 && templateObj.BEnables[i-1].checked && templateObj.config.BIoutData[i-1]!==0 && templateObj.config.BEffData[i-1]!==0 ) {
                    if (templateObj.config.device.fswCtrlPerPhase) {
                        row+='BUCK'+i.toString()+','+templateObj.config.BPin[i-1].toFixed(dec)+','+templateObj.config.BPout[i-1].toFixed(dec)+','+templateObj.config.BPdiss[i-1].toFixed(dec)+','+templateObj.config.device.buckInductorDCR[i-1][templateObj.FswDBX[i-1].selectedIndex].toFixed(dec)+','+templateObj.config.BInductorLoss[i-1].toFixed(dec)+','+templateObj.config.BEff[i-1].toFixed(dec)+';';
                    } else {
                        row+='BUCK'+i.toString()+','+templateObj.config.BPin[i-1].toFixed(dec)+','+templateObj.config.BPout[i-1].toFixed(dec)+','+templateObj.config.BPdiss[i-1].toFixed(dec)+','+templateObj.config.device.buckInductorDCR[i-1][templateObj.masterFSW.selectedIndex].toFixed(dec)+','+templateObj.config.BInductorLoss[i-1].toFixed(dec)+','+templateObj.config.BEff[i-1].toFixed(dec)+';'
                    }
                } else {
                    row+='BUCK'+i.toString()+',N/A,N/A,N/A,N/A,N/A,N/A;';
                }
            } else {
                let index=i-templateObj.config.device.buckCount;
                if (templateObj.BoostEnables[index-1].checked && templateObj.config.BoostIoutData[index-1]!==0 && templateObj.config.BoostEffData[index-1]!==0 ) {
                    row+='BOOST'+index.toString()+','+templateObj.config.BoostPin[index-1].toFixed(dec)+','+templateObj.config.BoostPout[index-1].toFixed(dec)+','+templateObj.config.BoostPdiss[index-1].toFixed(dec)+','+templateObj.config.device.boostInductorDCR[index-1][templateObj.BoostFswDBX[index-1].selectedIndex].toFixed(dec)+','+templateObj.config.BoostInductorLoss[index-1].toFixed(dec)+','+templateObj.config.BoostEff[index-1].toFixed(dec)+';';
                } else {
                    row+='BOOST'+index.toString()+',N/A,N/A,N/A,N/A,N/A,N/A;';
                }
            }
            
            // If last row, remove the last ; character
            if (i==templateObj.config.device.buckCount+templateObj.config.device.boostCount) {
                row=row.slice(0,-1);
            }
        }
        document.getElementById('switcherTable').rows=row;
        row='';
    }
    if (table=='LDO' || table=='ALL') { // LDO table
        for (let i=1; i<=templateObj.config.device.ldoCount; i++) {
            // If rail is in use
            if (templateObj.LDOEnables[i-1].checked) {
                row+=i.toString()+','+templateObj.config.LDOPin[i-1].toFixed(dec)+','+templateObj.config.LDOPout[i-1].toFixed(dec)+','+templateObj.config.LDOPdiss[i-1].toFixed(dec)+','+templateObj.config.LDOEff[i-1].toFixed(dec)+';';
            } else {
                row+=i.toString()+',N/A,N/A,N/A,N/A;';
            }
            
            // If last row, remove the last ; character
            if (i==templateObj.config.device.ldoCount) {
                row=row.slice(0,-1);
            }
        }
        document.getElementById('ldoTable').rows=row;
        row='';
    }
    if (table=='THERMAL' || table=='LDO' || table=='BUCK' || table=='BOOST' || table=='ALL') {
        let tres=templateObj.thermalResistanceInput.value;
        let tboard=templateObj.tempSlider.value;
        let tj=templateObj.config.icPdiss*tres/1000+tboard;
        row=templateObj.config.icPdiss.toFixed(dec)+','+templateObj.config.totalInductorLoss.toFixed(dec)+','+tboard.toFixed(dec)+','+tj.toFixed(dec);
        document.getElementById('thermalTable').rows=row;
        if (tj>140) { // Highlight junction temperature with red if over 140C
            document.getElementById('thermalTable').colStyles=',,,background-color:red'
        } else {
            document.getElementById('thermalTable').colStyles=',,,,'
        }
        row='';
    }
    if (table=='LDO' || table=='BUCK' || table=='BOOST' || table=='ALL') {
        row=templateObj.config.systemPin.toFixed(dec)+','+templateObj.config.systemPout.toFixed(dec)+','+templateObj.config.systemEff.toFixed(dec)+','+templateObj.config.systemIin.toFixed(dec);
        document.getElementById('systemTable').rows=row;    
    }
}

function calculateResults(buckorldo) {
    if (buckorldo == 'BUCK' || buckorldo == 'ALL') {
        templateObj.config.totalBuckInductorLoss=0;
        for (let rail=1; rail<=templateObj.config.device.buckCount; rail++) {
            // Check that the buck is enabled, in use for the phase configuration and efficiency data is available for it
            if (templateObj.config.phases[rail-1]!=-1 && templateObj.BEnables[rail-1].checked 
            && (templateObj.config.BIoutData[rail-1]!==0 || templateObj.config.BEffData[rail-1]!==0)) {
                templateObj.config.BPout[rail-1]=templateObj.config.BIout[rail-1]*templateObj.config.BVout[rail-1]/1000;
                templateObj.config.BPin[rail-1]=templateObj.config.BPout[rail-1]/templateObj.config.BEff[rail-1]*100;
                if (templateObj.config.device.fswCtrlPerPhase) {
                    templateObj.config.BInductorLoss[rail-1]=templateObj.config.device.buckInductorDCR[rail-1][templateObj.FswDBX[rail-1].selectedIndex]*Math.pow(templateObj.config.BIout[rail-1],2)/(1000000*templateObj.config.phases[rail-1]);
                } else {
                    templateObj.config.BInductorLoss[rail-1]=templateObj.config.device.buckInductorDCR[rail-1][templateObj.masterFSW.selectedIndex]*Math.pow(templateObj.config.BIout[rail-1],2)/(1000000*templateObj.config.phases[rail-1]);
                }
                templateObj.config.BPdiss[rail-1]=templateObj.config.BPin[rail-1]-templateObj.config.BPout[rail-1]-templateObj.config.BInductorLoss[rail-1];
                templateObj.config.totalBuckInductorLoss+=templateObj.config.BInductorLoss[rail-1];
            } else {
                templateObj.config.BPout[rail-1]=0;
                templateObj.config.BPin[rail-1]=0;
                templateObj.config.BPdiss[rail-1]=0;
                templateObj.config.BInductorLoss[rail-1]=0;
            }
        }
    }
    if (buckorldo == 'BOOST' || buckorldo == 'ALL') {
        templateObj.config.totalBoostInductorLoss=0;
        for (let rail=1; rail<=templateObj.config.device.boostCount; rail++) {
            // Check that the buck is enabled, in use for the phase configuration and efficiency data is available for it
            if (templateObj.BoostEnables[rail-1].checked 
            && (templateObj.config.BoostIoutData[rail-1]!==0 || templateObj.config.BoostEffData[rail-1]!==0)) {
                templateObj.config.BoostPout[rail-1]=templateObj.config.BoostIout[rail-1]*templateObj.config.BoostVout[rail-1]/1000;
                templateObj.config.BoostPin[rail-1]=templateObj.config.BoostPout[rail-1]/templateObj.config.BoostEff[rail-1]*100;
                templateObj.config.BoostInductorLoss[rail-1]=templateObj.config.device.boostInductorDCR[rail-1][templateObj.BoostFswDBX[rail-1].selectedIndex]*Math.pow(templateObj.config.BoostIout[rail-1],2)/1000000;
                templateObj.config.BoostPdiss[rail-1]=templateObj.config.BoostPin[rail-1]-templateObj.config.BoostPout[rail-1]-templateObj.config.BoostInductorLoss[rail-1];
                templateObj.config.totalBoostInductorLoss+=templateObj.config.BoostInductorLoss[rail-1];
            } else {
                templateObj.config.BoostPout[rail-1]=0;
                templateObj.config.BoostPin[rail-1]=0;
                templateObj.config.BoostPdiss[rail-1]=0;
                templateObj.config.BoostInductorLoss[rail-1]
            }
        }
    } 
    if (buckorldo == 'LDO' || buckorldo == 'ALL') {
        for (let rail=1; rail<=templateObj.config.device.ldoCount; rail++) {
            if (templateObj.LDOEnables[rail-1].checked) {
                templateObj.config.LDOPout[rail-1]=templateObj.config.LDOIout[rail-1]*templateObj.config.LDOVout[rail-1]/1000;
                // We assume that LDO input current is the output current + Iq (70 µA)
                if (templateObj.config.LDOVinMasterFlag) {
                    templateObj.config.LDOPin[rail-1]=(templateObj.config.LDOIout[rail-1]+70/1000)*templateObj.config.Vin/1000;
                } else {
                    templateObj.config.LDOPin[rail-1]=(templateObj.config.LDOIout[rail-1]+70/1000)*templateObj.config.LDOVin[rail-1]/1000;
                }
                templateObj.config.LDOPdiss[rail-1]=templateObj.config.LDOPin[rail-1]-templateObj.config.LDOPout[rail-1];
                templateObj.config.LDOEff[rail-1]=templateObj.config.LDOPout[rail-1]/templateObj.config.LDOPin[rail-1]*100;
            } else {
                templateObj.config.LDOPout[rail-1]=0;
                templateObj.config.LDOPin[rail-1]=0;
                templateObj.config.LDOPdiss[rail-1]=0;
                templateObj.config.LDOEff[rail-1]=0;
            }
        }
    }
    // Calculate system and thermal
    templateObj.config.systemPin=0;
    templateObj.config.systemPout=0;
    templateObj.config.icPdiss=0;
    for (let buck=1; buck<=templateObj.config.device.buckCount; buck++) {
        templateObj.config.systemPin+=templateObj.config.BPin[buck-1];
        templateObj.config.systemPout+=templateObj.config.BPout[buck-1];
        templateObj.config.icPdiss+=templateObj.config.BPdiss[buck-1];
    }
    for (let boost=1; boost<=templateObj.config.device.boostCount; boost++) {
        templateObj.config.systemPin+=templateObj.config.BoostPin[boost-1];
        templateObj.config.systemPout+=templateObj.config.BoostPout[boost-1];
        templateObj.config.icPdiss+=templateObj.config.BoostPdiss[boost-1];
    }
    for (let ldo=1; ldo<=templateObj.config.device.ldoCount; ldo++) {
        templateObj.config.systemPin+=templateObj.config.LDOPin[ldo-1];
        templateObj.config.systemPout+=templateObj.config.LDOPout[ldo-1];
        templateObj.config.icPdiss+=templateObj.config.LDOPdiss[ldo-1];
    }
    templateObj.config.totalInductorLoss=templateObj.config.totalBuckInductorLoss+templateObj.config.totalBoostInductorLoss;
    templateObj.config.systemPdiss=templateObj.config.systemPin-templateObj.config.systemPout;
    templateObj.config.systemIin=templateObj.config.systemPin/templateObj.config.Vin*1000;
    // Check for division by zero
    if (templateObj.config.systemPin===0) {
        templateObj.config.systemEff=0;
    } else {
        templateObj.config.systemEff=templateObj.config.systemPout/templateObj.config.systemPin*100;
    }
}